import numpy as np
import matplotlib.pyplot as plt

from sklearn import cross_validation, metrics
from sklearn.ensemble import RandomForestClassifier

def randomforests(x_train, y_train):

    clf = RandomForestClassifier(n_estimators=500, max_features='sqrt', n_jobs=-1, oob_score=True) # setting RF parameters
    CLF = clf.fit(x_train, y_train)
    print 'oob_score', CLF.oob_score_

    # Cross Validation
    kf = cross_validation.KFold(x_train.shape[0], n_folds=10, random_state=0)
    CV_pred_prob = []
    VALIDATION_index = []
    CV_pred = []
    for train_index, validation_index in kf:
        VALIDATION_index = VALIDATION_index + list(validation_index)
        clf.fit(x_train[train_index, :], y_train[train_index])
        pred_prob = clf.predict_proba(x_train[validation_index])
        CV_pred_prob = CV_pred_prob + list(pred_prob[:, 1])  ## becareful pred_prob
        cv_pred = clf.predict(x_train[validation_index])
        CV_pred = CV_pred + list(cv_pred)

    ## Calculate auc score, calculate sinsitivity, specificity and accuracy of cv
    y_train = y_train[VALIDATION_index]
    AUC_score = metrics.roc_auc_score(y_train, CV_pred_prob)
    print 'AUC_score :', AUC_score
    ACC_score = metrics.accuracy_score(y_train, CV_pred)
    print 'ACC_score :', ACC_score
    TPR = metrics.recall_score(y_train, CV_pred)
    print 'TPR (sensitivity) :', TPR
    TNR = (ACC_score * y_train.shape[0] - list(y_train).count(1) * TPR)/list(y_train).count(0)
    print 'TNR (specificity) :', TNR

if __name__ == "__main__":
    #protein_new
    x_train = np.loadtxt('x_train_protein_new.txt')
    y_train = np.loadtxt('y_train_protein_new.txt')
    randomforests(x_train, y_train)
